// RSI Smoothed BandsFBA Oscillator                                             
#property copyright "Scriptong"
#property link      "scriptong@mail.ru"

#property indicator_separate_window                         //    
#property indicator_buffers 5                                     //   5
                                          //       
#property indicator_color3 Blue                                  //    
#property indicator_color4 Red                                    //    
#property indicator_color5 MediumSeaGreen       //    BandsFBA Oscillator
 
extern int RSIPrice = PRICE_CLOSE;    //  RSI: 0 - Close, 1 - Open, 2 - High  . .
extern int RSIPeriod = 11;                                     //    RSI
extern int MA_Period = 8;                                 //   
extern int MA_Mode = MODE_LWMA;              //   : 0 - ,
                         // 1 - , 2 - , 3 - -
extern int BandsPeriod = 27;                                    //    
extern double K_Dev = 3.6;                      //  .   
extern int BandsFBAPeriod = 20;                                 //   BB
extern int BandsShift = 0;                                       //   
extern int OscPrice = 0;                                   //   (. )
extern double FrontPeriod = 1;                     //   ; .. <1
extern double BackPeriod = 55;                  //   ; .. <1
extern int Sens = 0;                                     //    .

double RSIBuffer[];               //       RSI
double RSI[];                                 //      RSI

double Up_Buffer[];                                //      
double Dn_Buffer[];                                 //      
double Main[];                                 //      

bool first = 1;                                                  //   
double per0,per1;                                                        // - EMA
int FBA=0;         // 1 -  , -1 -  , 0 -  MA
double sens;                                           //    

int init()
   {
   string short_name="RSI_Smoothed_BB("+RSIPeriod+","+BandsPeriod+","+
                     DoubleToStr(K_Dev, 2)+")";
   IndicatorShortName(short_name);                           //   

   SetIndexStyle(0, DRAW_NONE);      //   - ,    
   SetIndexBuffer(0, RSIBuffer);                   //     . 

   SetIndexBuffer(1, RSI);                         //     . 
   SetIndexStyle(1, DRAW_NONE);      //   - ,    

   SetIndexStyle(2, DRAW_LINE);                                            //  
   SetIndexBuffer(2, Up_Buffer);                   //     . 
   SetIndexDrawBegin(2, BandsPeriod);                //     BB

   SetIndexStyle(3, DRAW_LINE);                                            //  
   SetIndexBuffer(3, Dn_Buffer);                   //     . 
   SetIndexDrawBegin(3, BandsPeriod);                 //     BB

   SetIndexBuffer(4, Main);                        //     . 
   SetIndexStyle(4, DRAW_LINE);                                            //  

   first = 1;
   sens = Sens*Point;                                   //    

   if(FrontPeriod>1) FrontPeriod=2.0/(1+FrontPeriod);       // .  EMA
   if(BackPeriod>1) BackPeriod=2.0/(1+BackPeriod);               // .  EMA
   
   // FrontPeriod  BackPeriod      
   while(true) 
     {
      if (FrontPeriod==BackPeriod) 
        {
         per0=FrontPeriod; 
         per1=1; 
         break;
        }
      if (FrontPeriod>BackPeriod) 
        {
         FBA = -1;
         per0 = FrontPeriod;
         per1=BackPeriod;
        }
       else
        {
         FBA = 1; 
         per0 = BackPeriod; 
         per1 = FrontPeriod;
        }
      break;
     }

   return;
   }

int reinit()                                      //   
  {
   ArrayInitialize(Main,0.0);
   return(0);
  }
  
int start()
  {
// - 1 - ==============================    ? =============================
   if (Bars <= RSIPeriod || Bars <= BandsPeriod || Bars <= BandsFBAPeriod)        // 
         return;                                        //   ,  
// - 1 - ================================   ===============================

// - 2 - =========================     ====================
   int ic=IndicatorCounted();                            //   
   if (!first && Bars-ic-1 > 1) ic = reinit(); 
   int limit=Bars-ic-1; 
// - 2 - ================================   ===============================
   
// - 3 - =========================    RSI ====================
   for (int i = limit; i >= 0; i--)
     RSI[i] = iRSI(NULL, 0, RSIPeriod, RSIPrice, i);
   i = limit;                   
// - 3 - ================================   ===============================
     
// - 4 - ===================     RSI ==============
   for (i = limit; i >= 0; i--)
      {
      RSIBuffer[i] = iMAOnArray(RSI,0,MA_Period,0,MA_Mode,i);
// - 4 - ================================   ===============================

// - 5 - =======    ,    RSI =======
      double sum = 0.0;                                         //  
      int k = i + BandsPeriod - 1;                  //     
      while(k >= i)                     //      
        {
         double newres = RSIBuffer[k] - 50;                                 // 
         sum += newres*newres;                              //   
         k--;
        }
      double deviation = K_Dev*MathSqrt(sum/BandsPeriod);           //  
      Up_Buffer[i]= 50 + deviation;                                   //   
      Dn_Buffer[i]= 50 - deviation;                                    //   
// - 5 - ================================   ===============================
     
// - 6 - ====================      ==============
      bool reset = i==limit && ic==0;         //      
      if (reset) 
        {
         static double MA0prev=0, MA1prev=0, sma0prev=0; 
         static int BarsPrev=0;
        }
        
      int sh = i + BandsShift;                                                   // 

      double sma = iMA(NULL, 0, BandsPeriod, 0, 0, 0, sh);     //  Bollinger Bands
 
      double st=iStdDev(NULL, 0, BandsPeriod, 0, 0, 0, sh);       //   
      st = MathMax(st, sens);                            //   
      double std = 2*st;                                                      // 
      
      //  Bollinger Bands FBA
      double topB = sma + std;                                           //  
      double botB = sma-std;                                              //  

      //  
      double MA0 = EMA_FBA(st, MA0prev, per0, 0, i);
      double sma0 = EMA_FBA(sma, sma0prev, per0, 0, i);
      
      double MA1=EMA_FBA(MA0, MA1prev, per1, FBA, i);         //  ()
      
      double price = Price(OscPrice,i);
      double deltaB = topB - botB;                                       //  
      if (deltaB == 0) 
        double main = 1;
       else 
        main = (price-botB)/deltaB;
      Main[i] = 100*main;       //       
    
      // 
      if (first || BarsPrev != Bars) 
        { 
         BarsPrev = Bars;
         MA0prev = MA0;
         MA1prev = MA1;
         sma0prev = sma0;
        }
// - 6 - ================================   ===============================
      }
   return;
  }
   
// EMA        
double EMA_FBA(double C, double MA1, double period, int FBA, int i) 
  {
   if(period == 1) return(C);
   // . EMA 
   if(period>1) period=2.0/(1+period); 
   // EMA
   double ma=period*C+(1-period)*MA1; 
   //    
   switch(FBA) {
      case  0: //  MA
         if(FBA==0) return(ma); 
      case  1: //  
         if(C>MA1) return(ma); else return(C); 
      case -1: //  
         if(C<MA1) return(ma); else return(C); 
     }
  }
  
double Price(int ApplPrice, int i) 
  {
   switch(ApplPrice) 
     {
      case 0: return(Close[i]);
      case 1: return(Open[i]);
      case 2: return(High[i]);
      case 3: return(Low[i]); 
      case 4: return((High[i]+Low[i])/2); // Middle
      case 5: return((High[i]+Low[i]+Close[i])/3); // Typical
      case 6: return((High[i]+Low[i]+2*Close[i])/4); // Weighted
      default: return(Close[i]); // Close
     }
  }
